// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"

typedef long long ll;
typedef long double ld;

std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 5100;
const int MOD = 998244353;

ll add(ll a, ll b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	} else {
		return a + b;
	}
}

ll sub(ll a, ll b) {
	if (a - b < 0) {
		return a - b + MOD;
	} else {
		return a - b;
	}
}

ll mul(ll a, ll b) {
	return 1ll * a * b % MOD;
}

ll dp[N][N];

int main(void) {
	// #ifdef ONLINE_JUDGE
	// 	freopen(NAME".in", "r", stdin);
	// 	freopen(NAME".out", "w", stdout);
	// #endif

	fastIO;
	
	std::string str;
	std::cin >> str;

	std::string temp = "a";
	for (char i = 'b'; i <= 'z'; ++i) {
		std::string cur = temp;
		cur.push_back(i);
		cur += temp;
		temp.swap(cur);
		if (temp.size() >= str.size()) {
			break;
		}
	}

	for (int i = 1; i <= (int)str.size(); ++i) {
		for (int l = 1; l <= (int)str.size(); ++l) {
			dp[i][l] = dp[i - 1][l];
			if (l == 1) {
				if (str[i - 1] == 'a') {
					dp[i][l] = add(dp[i][l], 1ll);
				}
			} else {
				if (str[i - 1] == temp[l - 1]) {
					dp[i][l] = add(dp[i][l], dp[i - 1][l - 1]);
				}
			}
		}
	}

	ll ans = 0;
	for (int i = 1; (1 << i) - 1 <= (int)str.size(); ++i) {
		ans = add(ans, dp[(int)str.size()][(1 << i) - 1]);
	}

	std::cout << ans << '\n';

	return 0;
}
