using namespace std;

#include <unordered_set>
#include <queue>
#include "testlib.h"

const int max_total_len = 1000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_len = has_opt("l") ? opt<int>("l") : max_total_len;
    int len = rnd.wnext(1, max_len, 3);
    string s;
    for (int i = 0; i < len; ++i) {
        s.push_back(rnd.next('a', 'z'));
    }

    int rem_n = rnd.wnext(1, opt<int>("n"), 2);
    vector<string> a = {""};
    for (int i = 0; i < len; ++i) {
        bool sep = a.back().size() > 0 && rem_n > 0 && rnd.next(len - i) < rem_n;
        if (sep) {
            --rem_n;
            a.emplace_back("");
        }
        a.back() += s[i];
    }
    while (a.back().size() == 0) a.pop_back();
    int n = a.size();

    int max_m = opt<int>("m");
    int m = rnd.wnext(1, max_m, 3);


    printf("%d %d\n", a.size(), m);
    println(a.begin(), a.end());
    for (int i = 0; i < m; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%d", rnd.next(1, len));
    }
    printf("\n");
}

