#include "testlib.h"

char randChar() {
    return rnd.next(0, 25) + 'a';
}

void genTest() {
    int n = rnd.next(100000 / 2, 100000);
    int m = rnd.next(1, 100000);

    std::cout << n << ' ' << m << std::endl;

    for (int i = 0; i < m; ++i) {
        std::cout << rnd.next(0, 10000000);
        if (i == m - 1) {
            std::cout << std::endl;
        } else {
            std::cout << ' ';
        }
    }

    std::set<int> x;
    while ((int)x.size() < n) {
        x.insert(rnd.next(0, 10000000));
    }

    auto it = x.begin();
    while (n--) {
        long long c = rnd.next(0ll, 1000000000000ll);
        if (rnd.next(0, 1) == 0) {
            c = -c;
        }

        std::cout << *it << ' ' << c << std::endl;
        ++it;
    }
}

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);

    int first = atoi(argv[1]);
    int last = atoi(argv[2]);

    for (int test = first; test <= last; ++test) {
        startTest(test);
        genTest();
    }

    return 0;
}