#include <bits/stdc++.h>

#define int long long
#define pb emplace_back
#define mp make_pair
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long double ld;
typedef long long ll;

using namespace std;

mt19937 rnd(time(nullptr));

const int inf = 1e15;
const int M = 1e9 + 7;
const ld pi = atan2(0, -1);
const ld eps = 1e-6;

void solve(int tc){
    int n, m;
    cin >> n >> m;
    int ax, ay;
    cin >> ax >> ay;
    --ax, --ay;
    int bx, by;
    cin >> bx >> by;
    --bx, --by;

    vector<string> s(n);
    for(auto &e: s) cin >> e;

    vector<pair<int, int>> dir{{-1, 0},
                               {-1, 1},
                               {0, 1},
                               {1, 1},
                               {1, 0},
                               {1, -1},
                               {0, -1},
                               {-1, -1}
    };

    vector<vector<vector<int>>> dist(n, vector<vector<int>>(m, vector<int>(8, -1)));
    dist[ax][ay][0] = 0;
    deque<pair<pair<int, int>, int>> q;
    q.push_back({{ax, ay}, 0});

    while (!q.empty()) {
        int cx = q.front().x.x;
        int cy = q.front().x.y;
        int t = q.front().y;
        q.pop_front();

        if (s[cx][cy] == '.') {
            int nt = t + 1;
            if(dist[cx][cy][nt % 8] == -1){
                dist[cx][cy][nt % 8] = nt;
                q.push_back({{cx, cy}, nt});
            }
            for(int i = 0; i < 8; i += 2){
                int nx = cx + dir[i].x;
                int ny = cy + dir[i].y;
                if(nx < 0 || nx >= n || ny < 0 || ny >= m) {
                    continue;
                }
                if(dist[nx][ny][nt % 8] == -1){
                    dist[nx][ny][nt % 8] = nt;
                    q.push_back({{nx, ny}, nt});
                }
            }
        }
        else {
            int i = (s[cx][cy] - '0' + t) % 8;
            int nx = cx + dir[i].x;
            int ny = cy + dir[i].y;
            if(nx < 0 || nx >= n || ny < 0 || ny >= m) {
                continue;
            }
            if(dist[nx][ny][t % 8] == -1 || dist[nx][ny][t % 8] > t){
                dist[nx][ny][t % 8] = t;
                q.push_front({{nx, ny}, t});
            }
        }
    }
    cout << *min_element(all(dist[bx][by]));
}

bool multi = false;

signed main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    /*ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);*/
    int t = 1;
    if (multi)cin >> t;
    for (int i = 1; i <= t; ++i) {
        solve(i);
        cout << "\n";
    }
    return 0;
}