#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n, m);
    int x = 1, y = 1;

    int top = x - 1, bottom = n - x, left = y - 1, right = m - y;
    auto hcut = [&](int i) {
        if (i <= top) top -= i;
        else bottom = i - top - 1;
    };
    auto vcut = [&](int i) {
        if (i <= left) left -= i;
        else right = i - left - 1;
    };

    auto play = [&]() {
        int full = left ^ right ^ top ^ bottom;
        if ((full ^ bottom) < bottom) {
            cout << "R " << (top + 1 + (full ^ bottom)) << '\n';
            bottom ^= full;
        } else if ((full ^ top) < top) {
            cout << "R " << (top - (full ^ top)) << '\n';
            top ^= full;
        } else if ((full ^ right) < right) {
            cout << "C " << (left + 1 + (full ^ right)) << '\n';
            right ^= full;
        } else if ((full ^ left) < left) {
            cout << "C " << (left - (full ^ left)) << '\n';
            left ^= full;
        } else {
            exit(1);
        }
        cout.flush();
    };

    if (top ^ bottom ^ left ^ right) {
        cout << "1\n";
        cout.flush();
        play();
    } else {
        cout << "2\n";
        cout.flush();
    }

    while (top > 0 || bottom > 0 || left > 0 || right > 0) {
        in(char, type)
        in(int, i);

        if (type == 'R')
            hcut(i);
        else
            vcut(i);

        if (top == 0 && bottom == 0 && left == 0 && right == 0) {
            exit(2);
        } else {
            play();
        }
    }

}