#include <cstdio>
using namespace std;

int out_edge[500005];
int in_deg[500005];
bool vis[500005];

int cnt = 0;

void dfs(int x, bool monster) {
    if (vis[x]) return;
    vis[x] = 1;
    cnt += monster;
    int y = out_edge[x];
    if (--in_deg[y] == 0 || monster)
        dfs(y, !monster);
}

int main() {
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", out_edge + i);
        --out_edge[i];
        ++in_deg[out_edge[i]];
    }
    for (int i = 0; i < n; ++i)
        if (in_deg[i] == 0)
            dfs(i, true);

    for (int i = 0; i < n; ++i)
        dfs(i, false);

    printf("%d\n", cnt);
}
